MODULE STMBlinkerF100;
(* =========================================================================  
   Example ARM Cortex-M3 Oberon Program  
 
   Description:
     Led blinking approx. once per second

   Target:
     STM32F100 
     
   Tested on: 
     STM32VLDISCOVERY Evaluation Board
   
   References: 
     STM UM0919 STM32VLDISCOVERY User manual
     Oberon for Cortex-M3 Microcontrollers
   
   (c) 2012-2016 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

IMPORT Main, SYSTEM;

CONST
  RCCAPB2ENR = 040021018H;
  GPIOCCRH   = 040011004H;
  GPIOCODR   = 04001100CH;

PROCEDURE* Run;
VAR
  s, ledOn, ledOff: SET; 
  i, port, delay: INTEGER;
BEGIN
  (* Enable Port C clock *)
  SYSTEM.GET(RCCAPB2ENR, s);
  SYSTEM.PUT(RCCAPB2ENR, s + {4});
  (* Port C bit 9 is a push-pull output GPIOCCRH:7:4 = 0011 *)
  SYSTEM.GET(GPIOCCRH, s);
  SYSTEM.PUT(GPIOCCRH, s - {7, 6} + {5, 4});
  port := GPIOCODR;
  delay := 400000;
  ledOff := {};
  ledOn := {9};
  WHILE TRUE DO
    SYSTEM.PUT(port, ledOn);
    FOR i := 1 TO delay DO END;
    SYSTEM.PUT(port, ledOff);
    FOR i := 1 TO delay DO END
  END 
END Run;
    
BEGIN
  Run()
END STMBlinkerF100.
  
  
                  
